#include <windows.h>                                        //WINAPI
#include <stdlib.h>                                         //instrukcje operacji na pamieci
                                                            //  malloc i free
#include <stdio.h>                                          //zmienna FILE i instrukcje operacji
                                                            //  na plikach
#include "ztypes.h"                                         //podstawowe typy danych
#include "in2.h"                                            //header z definicja struktury dla
                                                            //  plug-ina wejsciowego
#include "pokey.h"                                          //emulator pokeya
#include "tmc_player.h"                                     //player tmc v1
#include "mpt_player.h"                                     //player mpt v2.4
#include "compile.h"                                        //opcje kompilacji

/**********************************************************
 definicje podstawowych stalych
 **********************************************************/

#define IN_ATARI_VER 0.90                                   //wersja plug-in'a
#define NCH 2                                               //maksymalna ilosc kanalow
#define SAMPLERATE 44100                                    //defoltowy sample rate
#define BPS 16                                              //maksymalna ilosc bitow na kanal

/**********************************************************
 definicje makr
 **********************************************************/

#define WM_WA_MPEG_EOF WM_USER+2                            //wydarzenie "koniec odtwarzania"
                                                            //  wysylane do WinAmp'a

/**********************************************************
 zmienne globalne
 **********************************************************/

extern  In_Module mod;                                      //struktura z informacjami o
                                                            //  plug-in'ie przeznaczona dal WinAmp'a
                                                            //  definiowana pod koniec tego pliku
zbyte   Paused=0;                                           //czy jest aktywna pauza utworu
zint32  SeekNeeded=-1;                                      //miejsce, do ktorego uzytkownik
                                                            //  zazyczyl sobie przewinac utwor lub
                                                            //  -1, jezeli sobie tego nie zazyczyl
zbyte   SampleBuffer[576*NCH*(BPS/8)*2];                    //bufor z samplami przekazywany do
                                                            //  plug-in'a wyjsciowego
zbyte   KillDecodeThread=0;                                 //flaga zabijania watku
                                                            //  odtwarzajacego utwor
HANDLE  ThreadHandle=INVALID_HANDLE_VALUE;                  //uchwyt do watku odtwarzajacego
                                                            //  utwor
zint32  DecodePosMs;                                        //miejsce odtwarzania w utworze
zint32  PlayerRate;                                         //czestotliwosc wywolywania playera
zbyte   EmulatedPokeys;                                     //ilosc emulowanych pokey'i

DWORD WINAPI __stdcall DecodeThread(zvoid *b);              //deklaracja watku odtwarzajacego

zint32  (*player_LoadFile)(zchar * FileName);               //funkcje pomocnicze playerow
zvoid   (*player_Free)(zvoid);
zvoid   (*player_Reset)(zvoid);
zint32  (*player_GetFPJ)(zvoid);
zint32  (*player_GetRealSongLengthInMs)(zvoid);
zchar*  (*player_GetSongName)(zvoid);
zint32  (*player_PlayerCall)(zvoid);
zvoid   (*player_MakeJumpToMs)(zint32 ToMs);
zbyte   (*player_GetAUDF)(zbyte channel);
zbyte   (*player_GetAUDC)(zbyte channel);
zbyte   (*player_GetAUDCTL)(zbyte pokey);

/**********************************************************
 funkcje wewnetrzne
 **********************************************************/

//wypelnia bufor samplami i zwraca ilosc sampli ktorymi
//  ten buffor wypelnil
//  zero oznacza ze juz wiecej sampli nie bedzie
//  (koniec utworu)
zint get_576_samples(zvoid)
{
  zbyte ToDo;                                               //zwrot pokeya (czy skonczyly sie
                                                            //  cykle czy miejsce w buforze)
  zint32 ReturnValue;                                       //zwracana ilosc sampli

  while(1) {
    ToDo=EmulatePokeys();                                   //sprawdzamy stan pokeya
    if (ToDo==1) {                                          //jezeli zavbraklo cykli
      if (player_PlayerCall()<0) {                          //wywolujemy playera
        ReturnValue=GetBufferCounter()*(BPS/8)*             //jezeli player powie nam ze napotkal
        EmulatedPokeys;
                                                            //  koniec utworu lub skok to
        SetBufferCounter(0);                                //zerujemy bufor
        return ReturnValue;                                 //i wychodzimy
      }
      for(zbyte i=0;i<EmulatedPokeys;i++) {                 //ustawiamy AUDCTL
        SetAUDCTL(i,player_GetAUDCTL(i));
      }
//ZLE
//      SetAUDCTL(0,0x40);
//
      for(zbyte i=0;i<(EmulatedPokeys<<2);i++) {            //AUDF i AUDC na wartosci zwrocone
        SoundFC(i,player_GetAUDF(i),player_GetAUDC(i));     //  przez player
      }
//ZLE
//      SoundFC(0,97,2*16+4);
//
      SetCyclesCounter((zint32)(HIGH_CLOCK/PlayerRate));    //ustawiamy ilosc cykli do nastepnego
                                                            //  wywolania playera
    } else {                                                //jezeli zabraklo miejsca w buforze
      SetBufferCounter(0);                                  //zerujemy bufor
      return 576*(BPS/8)*EmulatedPokeys;                    //i wychodzimy
    }
  }
}

//watek odtwarzajacy utwor
DWORD WINAPI __stdcall DecodeThread(zvoid *b)
{
  zbyte done=0;
  zint32 l;

  while (!*((zbyte *)b))                                    //petla dotad, dokad ne przerwie ja
  {                                                         //  zewnetrzna zmienna
    if (SeekNeeded!=-1) {                                   //jezeli uzytkownik chce zmienic
                                                            //  miejsce odtwarzania
      DecodePosMs=SeekNeeded-(SeekNeeded%1000);             //obliczamy nowe miejsce z dokladnoscia
                                                            //  do 1 sekundy
      SeekNeeded=-1;                                        //kasujemy znacznik potrzeby przesuwu
      done=0;                                               //kasujemy znacznik konca odtwarzania
      mod.outMod->Flush(DecodePosMs);                       //przesuwamy licznik w plug-in'ie
                                                            //  wyjsciowym
      SetBufferCounter(0);                                  //opruzniamy nasz bufor
      player_MakeJumpToMs(DecodePosMs);                     //kazemy playerowi skoczyc do nowej
                                                            //  pozycji odtwarzania
    }
    if (done) {                                             //jezeli mamy konczyc
      mod.outMod->CanWrite();                               //???
      if (!mod.outMod->IsPlaying()) {                       //jezeli muzyczka juz nie gra
                                                            //  (z bufora)
        PostMessage(mod.hMainWindow,WM_WA_MPEG_EOF,0,0);    //wysylamy do WinAmp'a zdarzenie, ze
        return 0;                                           //juz nie chcemy grac i konczymy watek
      }
      Sleep(10);                                            //jezeli muzyczka jeszcze gra to
                                                            //czekamy troszke
    } else  if (mod.outMod->CanWrite()>=((576*              //jezeli jeszcze nie konczymy
      EmulatedPokeys*(BPS/8))
                                                            //sprawdzamy czy mozna wysylac sample
      /*<<(mod.dsp_isactive()?1:0)*/)) {
      l=get_576_samples();                                  //zapelniamy bufor samplami
      if (!l) {                                             //jezeli zapelnienie sie nie powiodlo
        done=1;                                             //dajemy znak ze chcemy konczyc
      } else {
        mod.SAAddPCMData(SampleBuffer,                      //???
          EmulatedPokeys,BPS,DecodePosMs);
        mod.VSAAddPCMData(SampleBuffer,                     //???
          EmulatedPokeys,BPS,DecodePosMs);
        DecodePosMs+=(576*1000)/SAMPLERATE;                 //przesuwamy pozycje songu do przodu
//          if (mod.dsp_isactive()) {                         //jezeli jest wlaczone dsp
//            l=mod.dsp_dosamples((short *)SampleBuffer,      //obliczamy prawdziwa wielkosc bufora
//              l/EmulatedPokeys/(BPS/8),BPS,
//              EmulatedPokeys,SAMPLERATE)*
//              (EmulatedPokeys*(BPS/8));
//          }
        mod.outMod->Write((zchar *)SampleBuffer,l);         //wysylamy bufor do plug-in'a odtw.
      }
    } else {                                                //jezeli muzyka jeszcze gra
      Sleep(20);                                            //czekamy
    }
  }
  return 0;
}

//sprawdza rozszerzenie pliku i zwraca
//  0-nieznany
//  1-tmc
//  2-tm8
//  3-mpt
zbyte CheckFileNameExt(zchar *FileName)
{
  if (!FileName) {return 0;}
  zint i=0;
  zint point=-1;
  while (FileName[i]) {
    if (FileName[i]=='.') {point=i;}
    i++;
  }
  if (point==-1) {return 0;}
#ifdef TMC_COMPILE
  if (!_stricmp(&(FileName[point]),".tmc")) {return 1;}
  if (!_stricmp(&(FileName[point]),".tm8")) {return 2;}
#endif
#ifdef MPT_COMPILE
  if (!_stricmp(&(FileName[point]),".mpt")) {return 3;}
#endif
  return 0;
}

/**********************************************************
 funkcje wykorzystywane przez WinAmp'a
 **********************************************************/

//otwiera okienko konfiguracyjne plug-in'a

zvoid plugin_Config(HWND hwndParent)
{
  MessageBox(hwndParent,"No configuration window yet\n"
    "try sometime later",
    "Atari plug-in Configuration",MB_OK);
}

//otwiera okienko "O plug-in'ie"

zvoid plugin_About(HWND hwndParent)
{
  zchar s[1024];

  sprintf(s,"Atari WinAmp input plug-in ver %04.2f\n"
    "writen by adept_zap\n\n"
    "Pokey emulation ver %04.2f\n"
#ifdef TMC_COMPILE
    "tmc v1 format unit ver %04.2f\n"
#endif
#ifdef MPT_COMPILE
    "mpt v2.4 format unit ver %04.2f\n"
#endif
    "\n"
    "currently suported extensions: "
#ifdef TMC_COMPILE
    "tmc tm8 "
#endif
#ifdef MPT_COMPILE
    "mpt "
#endif
    "\n"
    ,
    IN_ATARI_VER,POKEY_VER
#ifdef TMC_COMPILE
    ,TMC_V1_PLAYER_VER
#endif
#ifdef MPT_COMPILE
    ,MPT_V2_4_PLAYER_VER
#endif
  );
  MessageBox(hwndParent,s,"About Atari plug-in",MB_OK);
}

//inicjalizuje plug-in'a

zvoid plugin_Init(zvoid)
{
  ThreadHandle=INVALID_HANDLE_VALUE;
  player_LoadFile=NULL;
  player_Free=NULL;
  player_Reset=NULL;
  player_GetFPJ=NULL;
  player_GetRealSongLengthInMs=NULL;
  player_GetSongName=NULL;
  player_PlayerCall=NULL;
  player_MakeJumpToMs=NULL;
  player_GetAUDF=NULL;
  player_GetAUDC=NULL;
  player_GetAUDCTL=NULL;
}

//deinicjalizuje plug-in'a

zvoid plugin_Quit(zvoid)
{
}

//zwraca informacje o rozpoznanym pliku

zvoid plugin_GetFileInfo( zchar   *FileName,
                          zchar   *Title,
                          zint    *LengthInMs)
{
  //DO ZROBIENIA: jezeli nie ma nazwy songu to zwrocic
  //  nazwe pliku
  if ((!FileName)||(!*FileName)) {
    if (Title && player_GetSongName) {
      strcpy(Title,player_GetSongName());
    }
    if (LengthInMs && player_GetRealSongLengthInMs) {
      *LengthInMs=player_GetRealSongLengthInMs();
    }
  } else {
    if (Title) {
      zbyte ext=CheckFileNameExt(FileName);
//DO ZROBIENIA: can't read file: filename
      switch (ext) {
#ifdef TMC_COMPILE
        case 1:
          if (tmc_GetFileInfoName(FileName,Title)<0) {
            strcpy(Title,"can't read file");
          }
          break;
        case 2:
          if (tmc_GetFileInfoName(FileName,Title)<0) {
            strcpy(Title,"can't read file");
          }
          break;
#endif
#ifdef MPT_COMPILE
        case 3:
          if (mpt_GetFileInfoName(FileName,Title)<0) {
            strcpy(Title,"can't read file");
          }
          break;
#endif
        default:
          strcpy(Title,"unrecognized extension");
      }
    }
    if (LengthInMs) {*LengthInMs=1000*60*5;}
  }
  return;
}

//nie wiem co to daje
zint plugin_InfoBox(zchar *file,HWND hwndParent)
{
  return 0;
}

//czy ten plik potrafimy odtworzyc
zint plugin_IsOurFile(zchar *FileName)
{
    return 0;
}

//zacznij grac
zint plugin_Play(zchar *FileName)
{
  zint32 MaxLatency;
  zint32 ThreadId;

  if (mod.outMod==NULL) {                                   //no to klops, nie ma plugina
    MessageBox(mod.hMainWindow,"No output plug-in",         //  wyjsciowego
      "Error",MB_OK);
    return 1;                                               //no to i wychodzimy z bledem
  }
  zbyte ext=CheckFileNameExt(FileName);
  switch (ext) {
#ifdef TMC_COMPILE
    case 1:
      EmulatedPokeys=2;
      player_LoadFile=tmc_LoadFile;
      player_Free=tmc_Free;
      player_Reset=tmc_Reset;
      player_GetFPJ=tmc_GetFPJ;
      player_GetRealSongLengthInMs=tmc_GetRealSongLengthInMs;
      player_GetSongName=tmc_GetSongName;
      player_PlayerCall=tmc_PlayerCall;
      player_MakeJumpToMs=tmc_MakeJumpToMs;
      player_GetAUDF=tmc_GetAUDF;
      player_GetAUDC=tmc_GetAUDC;
      player_GetAUDCTL=tmc_GetAUDCTL;
      break;
    case 2:
      EmulatedPokeys=2;
      player_LoadFile=tmc_LoadFile;
      player_Free=tmc_Free;
      player_Reset=tmc_Reset;
      player_GetFPJ=tmc_GetFPJ;
      player_GetRealSongLengthInMs=tmc_GetRealSongLengthInMs;
      player_GetSongName=tmc_GetSongName;
      player_PlayerCall=tmc_PlayerCall;
      player_MakeJumpToMs=tmc_MakeJumpToMs;
      player_GetAUDF=tmc_GetAUDF;
      player_GetAUDC=tmc_GetAUDC;
      player_GetAUDCTL=tmc_GetAUDCTL;
      break;
#endif
#ifdef MPT_COMPILE
    case 3:
      EmulatedPokeys=1;
      player_LoadFile=mpt_LoadFile;
      player_Free=mpt_Free;
      player_Reset=mpt_Reset;
      player_GetFPJ=mpt_GetFPJ;
      player_GetRealSongLengthInMs=mpt_GetRealSongLengthInMs;
      player_GetSongName=mpt_GetSongName;
      player_PlayerCall=mpt_PlayerCall;
      player_MakeJumpToMs=mpt_MakeJumpToMs;
      player_GetAUDF=mpt_GetAUDF;
      player_GetAUDC=mpt_GetAUDC;
      player_GetAUDCTL=mpt_GetAUDCTL;
      break;
#endif
    default:
      MessageBox(mod.hMainWindow,
        "unrecognized file extension","Error",MB_OK);
      return 1;
  }
  if (player_LoadFile(FileName)<0) {return 1;}              //probujemy otworzyc plik
  player_Reset();                                           //resetujemy stan playera
  PlayerRate=player_GetFPJ()*50;                            //ustawiamy z jaka czestotliwoscia
                                                            //  ma byc wywolywany player
  InitPokey(44100,EmulatedPokeys);                          //inicjalizujemy pokeya
  if (EmulatedPokeys==1) {
    SetExternalBuffer(SampleBuffer,576,MT_S16_MONO);        //ustawiamy dla niego bufor
  }
  if (EmulatedPokeys==2) {
    SetExternalBuffer(SampleBuffer,576,MT_S16_STEREO);      //ustawiamy dla niego bufor
  }
  SetBufferCounter(0);                                      //resetujemy bufor i
  SetCyclesCounter(0);                                      //ilosc cykli do odegrania
  for(zbyte i=0;i<EmulatedPokeys;i++) {                     //resetujemy AUDCTL w pokey'ach
    SetAUDCTL(i,0);
  }
  for(zbyte i=0;i<(EmulatedPokeys<<2);i++) {                //resetujemy AUDF i AUDC w pokey'ach
      SoundFC(i,100,0);
  }
  Paused=0;                                                 //utwor nie jest zpauzowany
  DecodePosMs=0;                                            //utwor zaczyna sie od poczatku
  SeekNeeded=-1;                                            //i nie chcemy tego zmieniac
  MaxLatency=mod.outMod->Open(SAMPLERATE,EmulatedPokeys,    //probujemy otworzyc plug-in wyjsciowy
    BPS,-1,-1);
  if (MaxLatency<0) {return 1;}                             //  do zapisu
  mod.SetInfo((SAMPLERATE*BPS*EmulatedPokeys)/1000,         //ustawiamy informacje o utworze
    SAMPLERATE/1000,EmulatedPokeys,1);
  mod.SAVSAInit(MaxLatency,SAMPLERATE);                     //???
  mod.VSASetInfo(SAMPLERATE,EmulatedPokeys);                //???
  mod.outMod->SetVolume(-666);                              //ustawiamy glosnosc na wartosc z
                                                            //  WinAmp'a
  KillDecodeThread=0;                                       //nie konczymy watku odtwarzajacego
  ThreadHandle=(HANDLE)CreateThread(NULL,0,                 //tworzymy watek odtwarzajacy
    (LPTHREAD_START_ROUTINE)DecodeThread,
    (void *)&KillDecodeThread,0,(DWORD *)&ThreadId);
  return 0;                                                 //powrot bez bledu
}

//pauzuj utwor
zvoid plugin_Pause(zvoid)
{
  Paused=1;
  mod.outMod->Pause(1);                                     //niech plig-in wyjsciowy zpauzuje
                                                            //  utwor
}

//odpauzuj utwor
zvoid plugin_UnPause(zvoid)
{
  Paused=0;
  mod.outMod->Pause(0);                                     //niech plug-in wyjsciowy odpauzuje
                                                            //  utwor
}

//czy utwor jest zpauzowany
zint plugin_IsPaused(zvoid)
{
  return Paused;
}

//przestan grac utwor
zvoid plugin_Stop(zvoid)
{
  if (ThreadHandle!=INVALID_HANDLE_VALUE)                   //jezeli watek odtwarzajacy
  {                                                         //  jest wlaczony
    KillDecodeThread=1;                                     //wysylamy mu sygnal zeby sie zakonczyl
    if (WaitForSingleObject(ThreadHandle,INFINITE)==        //jezeli nie chce sie on zakonczyc
      WAIT_TIMEOUT)                                         //  po dobroci
    {
      TerminateThread(ThreadHandle,0);                      //konczymy go sila
    }
    CloseHandle(ThreadHandle);                              //zamykamy watek odtwarzajacy
    ThreadHandle=INVALID_HANDLE_VALUE;
  }
  mod.outMod->Close();                                      //zamykamy odtwarzanie w plug-in'ie
                                                            //  wyjsciowym
  mod.SAVSADeInit();                                        //???
  if (player_Free) {player_Free();}                         //zwalniamy player pliku
}

//zwraca dlugosc utworu w milisekundach
zint plugin_GetLength(zvoid)
{
  if (player_GetRealSongLengthInMs) {
    return player_GetRealSongLengthInMs();
  }
}

//zwraca dlugosc utworu ktory juz zostal odtworzony
zint plugin_GetOutputTime(zvoid)
{
  return mod.outMod->GetOutputTime();
}

//ustawia utwor na dany czas odtwarzania
zvoid plugin_SetOutputTime(zint TimeInMs)
{
  SeekNeeded=TimeInMs;
}

//ustawia glosnosc odtwarzania
zvoid plugin_SetVolume(zint Volume)
{
  mod.outMod->SetVolume(Volume);
}

//ustawia panning
zvoid plugin_SetPan(zint Pan)
{
  mod.outMod->SetPan(Pan);
}

//ustawia equalizer
zvoid plugin_EQSet(zint on,zchar data[10],zint preamp)
{
}

/**********************************************************
 struktura informacyjna dla WinAmp'a
 **********************************************************/

In_Module mod={
    IN_VER,
    "adept_zap Atari input plug-in",
    0,0,
#ifdef TMC_COMPILE
    "tmc\0theta music composer file\0tm8\0theta music composer file\0"
#endif
#ifdef MPT_COMPILE
    "mpt\0music protracker file\0"
#endif
    ,
    1,
    1,
    plugin_Config,
    plugin_About,
    plugin_Init,
    plugin_Quit,
    plugin_GetFileInfo,
    plugin_InfoBox,
    plugin_IsOurFile,
    plugin_Play,
    plugin_Pause,
    plugin_UnPause,
    plugin_IsPaused,
    plugin_Stop,
    plugin_GetLength,
    plugin_GetOutputTime,
    plugin_SetOutputTime,
    plugin_SetVolume,
    plugin_SetPan,
    0,0,0,0,0,0,0,0,0,
    0,0,
    plugin_EQSet,
    0,NULL};

/**********************************************************
 funkcje exportowane
 **********************************************************/

#ifdef __cplusplus
extern "C" {
#endif
  __declspec(dllexport) In_Module *winampGetInModule2()
  {
    return &mod;
  }
#ifdef __cplusplus
}
#endif

